<?php

namespace App\Http\Controllers\admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Str;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\URL;
use App\Models\User;
use App\Models\Settings;
use App\Helpers\helper;
use App\Models\Appointments;
use App\Models\AppointmentSlots;
use App\Models\Businesscard;
use App\Models\Businesscontact;
use App\Models\Inquiry;
use App\Models\PromotionalVideos;
use App\Models\BusinessReorderSection;
use App\Models\Service;
use App\Models\Testimonial;
use App\Models\Timings;
use App\Models\Transaction;
use App\Models\Plans;

class UserController extends Controller
{
    public function index(Request $request)
    {
        $userlist = User::with('plans_info', 'business_count', 'appointments_count')->where('type', 2)->orderByDesc('id')->get();
        User::where('id', 10)->update(['payment_id' => '', 'plan_id' => '', 'purchase_amount' => '', 'purchase_date' => '', 'payment_type' => '']);
        return view('admin.users.users', compact('userlist'));
    }
    public function userregister(Request $request)
    {
        return view('admin.auth.register');
    }
    public function register(Request $request)
    {
        return $request->all();
        die();
        $request->validate([
            'name' => 'required',
            'email' => 'required|email|unique:users,email',
            'mobile' => 'required',
            'password' => 'required',
        ], [
            "name.required" => trans('messages.name_required'),
            "email.required" => trans('messages.email_required'),
            "email.email" => trans('messages.valid_email'),
            "mobile.required" => trans('messages.mobile_required'),
            "password.required" => trans('messages.password_required'),
        ]);
        $checkslug = User::where('slug', Str::slug($request->name, '-'))->first();
        if ($checkslug != "") {
            $lastslug = User::select('id')->orderByDesc('id')->first();
            $newslug = Str::slug($request->name . "" . ($lastslug->id + 1), '-');
        } else {
            $newslug = Str::slug($request->name, '-');
        }
        $set_timezone = Settings::where('vendor_id', '1')->first();
        date_default_timezone_set($set_timezone->timezone);
        $user = new User;
        $user->name = $request->name;
        $user->email = $request->email;
        $user->password = Hash::make($request->password);
        $user->mobile = $request->mobile;
        $user->image = 'default.png';
        $user->login_type = "email";
        $user->type = 2;
        $user->is_verified = 2;
        $user->is_available = 1;
        $user->slug = $newslug;
        $user->save();
        return redirect(URL::to('admin'))->with('success', trans('messages.success'));
    }
    public function login(Request $request)
    {
        return view('admin.auth.login');
    }
    public function checklogin(Request $request)
    {
        try{
            if( ini_get('allow_url_fopen') ) {
                $payload = file_get_contents('https://paponapps.co.in/api/keyverify.php?url='.str_replace('checklogin', '', url()->current()).'&type=login');
                $obj = json_decode($payload);
                $obj->status = '1';

                if ($obj->status == '1') {
                    $request->validate([
                        'email' => 'required|email',
                        'password' => 'required'
                    ], [
                        'email.required' => trans('messages.email_required'),
                        'email.email' => trans('messages.valid_email'),
                        'password.required' => trans('messages.password_required'),
                    ]);
                    if (Auth::attempt($request->only('email', 'password'))) {
                        if (Auth::user()->type == "1") {
                            if (Auth::user()->is_available == "1") {
                                if (Auth::user()->is_verified == "1") {
                                    return redirect(URL::to('admin/dashboard'));
                                }
                            } else {
                                return redirect()->back()->with('error', trans('messages.blocked'));
                            }
                        } elseif (Auth::user()->type == "2") {
                            if (Auth::user()->is_available == "1") {
                                if (Auth::user()->is_verified == "1") {
                                    return redirect(URL::to('admin/dashboard'));
                                } else {
                                    $otp = rand(000000, 999999);
                                    $name = Auth::user()->name;
                                    $msg = trans('messages.email_verification_code_here');
                                    $logo = Settings::where('vendor_id', 1)->select('logo')->first()->logo;
                                    $data = ['title' => trans('messages.email_code'), 'email' => $request->email, 'name' => $name, 'otp' => $otp, 'msg' => $msg, 'logo' => $logo];
                                    if(env('MAIL_USERNAME') == "MAIL_USERNAME"){
                                        return redirect(URL::to('admin'))->with('error', trans('messages.email_error'));
                                    }
                                    $sendmail = Mail::send('email.otpverification', $data, function ($message) use ($data) {
                                        $message->from(env('MAIL_USERNAME'))->subject($data['title']);
                                        $message->to($data['email']);
                                    });
                                    if ($sendmail == true) {
                                        Auth::user()->otp = $otp;
                                        Auth::user()->save();
                                        session()->put('verification_email', $request->email);
                                        return redirect(URL::to('admin/otp-verification'))->with('success', trans('messages.otp_sent'));
                                    } else {
                                        return redirect(URL::to('admin'))->with('error', trans('messages.email_error'));
                                    }
                                }
                            } else {
                                return redirect(URL::to('admin'))->with('error', trans('messages.blocked'));
                            }
                        } else {
                            return redirect(URL::to('admin'))->with('error', trans('messages.user_doesnt_exist'));
                        }
                    } else {
                        return redirect(URL::to('admin'))->with('error', trans('messages.invalid_email_password'));
                    }
                } elseif ($obj->status == '3') {
                    return redirect('/admin')->with('error', $obj->message);
                } else {
                    return redirect('/admin/verification')->with('error', $obj->message);
                }
            } else {
                return redirect('/admin')->with('error', "allow_url_fopen function is disabled from server. please enable allow_url_fopen or contact to your server support.");
            }
        }catch(Exception $exception){
            return back()->withError($exception->getMessage())->withInput();    
        }
    }
    public function logout(Request $request)
    {
        Auth::logout();
        session()->flush();
        return redirect('admin');
    }
    public function addusers(Request $request)
    {
        $plans = Plans::select('id', 'name')->get();
        return view('admin.users.add', compact('plans'));
    }
    public function storeuser(Request $request)
    {
        $request->validate([
            'name' => 'required',
            'email' => 'required|email|unique:users,email',
            'mobile' => 'required',
            'password' => 'required',
        ], [
            "name.required" => trans('messages.name_required'),
            "email.required" => trans('messages.email_required'),
            "email.email" => trans('messages.valid_email'),
            "mobile.required" => trans('messages.mobile_required'),
            "password.required" => trans('messages.password_required'),
        ]);
        $checkslug = User::where('slug', Str::slug($request->name, '-'))->first();
        if ($checkslug != "") {
            $lastslug = User::select('id')->orderByDesc('id')->first();
            $newslug = Str::slug($request->name . "" . ($lastslug->id + 1), '-');
        } else {
            $newslug = Str::slug($request->name, '-');
        }
        $set_timezone = Settings::where('vendor_id', '1')->first();
        date_default_timezone_set($set_timezone->timezone);
        $user = new User;
        $user->name = $request->name;
        $user->email = $request->email;
        $user->password = Hash::make($request->password);
        $user->mobile = $request->mobile;
        $user->image = 'default.png';
        $user->login_type = "email";
        $user->type = 2;
        $user->is_verified = $request->is_verified;
        $user->admin_note = $request->admin_note;
        $user->is_available = 1;
        $user->slug = $newslug;
        $user->plan_id = $request->plan;
        $user->purchase_date = date("Y-m-d H:i:s");
        $user->save();

        return redirect(URL::to('admin/users'))->with('success', trans('messages.success'));
    }
    public function getuser(Request $request)
    {
        $data = array();
        $data['userdata'] = User::with('plans_info')->find($request->id);
        $data['plans'] = Plans::select('id', 'name')->get();

        if (empty($data['userdata'])) {
            abort(404);
        }
        return view('admin.users.edit', $data);
    }
    public function updateuser(Request $request)
    {
        $userdata = User::where('id', $request->id)->first();
        $request->validate(
            [
                'name' => 'required',
                'email' => 'required|email|unique:users,email,' . $userdata->id,
                'mobile' => 'required',
                'plan' => 'required',
                'is_verified' => 'required',
            ], 
            [
                "name.required" => trans('messages.name_required'),
                "slug.required" => trans('messages.slug_required'),
                "email.required" => trans('messages.email_required'),
                "email.email" => trans('messages.valid_email'),
                "mobile.required" => trans('messages.mobile_required'),
                "plan.required" => trans('messages.plan_select'),
                "is_verified.required" => trans('messages.is_verified_required'),
            ]
        );
        if ($request->file('profile') != "") {
            $userdata = User::find($request->id);
            $request->validate([
                'profile' => 'image|max:1024',
            ], [
                "profile.image" => trans('messages.enter_image_file'),
                "profile.max" => trans('messages.image_max_size'),
            ]);
            if (file_exists(storage_path('app/public/admin-assets/images/profile/' . $userdata->image))) {
                unlink(storage_path('app/public/admin-assets/images/profile/' . $userdata->image));
            }
            $new_name = 'user-' . uniqid() . '.' . $request->profile->getClientOriginalExtension();
            $request->profile->move(storage_path('app/public/admin-assets/images/profile/'), $new_name);
            User::where('id', $request->id)->update(['image' => $new_name]);
        }
        $userdata->name = $request->name;
        $userdata->email = $request->email;
        $userdata->mobile = $request->mobile;
        $userdata->is_verified = $request->is_verified;
        $userdata->admin_note = $request->admin_note;
        $userdata->plan_id = $request->plan;
        $userdata->purchase_date = date("Y-m-d H:i:s");
        $userdata->save();
        return redirect(route('users'))->with('success', trans('messages.success'));
    }
    public function resetpassword(Request $request)
    {
        $data = User::find($request->id);
        if (empty($data)) {
            abort(404);
        }
        return view('admin.users.resetpassword', compact('data'));
    }
    public function reset(Request $request)
    {
        $request->validate([
            'currentpassword' => 'required',
            'password' => 'required',
            'password_confirmation' => 'required_with:password|same:password',
        ], [
            "currentpassword.required" => trans('messages.current_password_required'),
            'password.required' => trans('messages.password_required'),
            'password_confirmation.required_with' => trans('messages.confirm_password_required'),
            'password_confirmation.same' => trans('messages.new_password_diffrent'),
        ]);
        $data = User::find($request->id);
        if (Hash::check($request->currentpassword, $data->password)) {
            User::where('id', $request->id)->update(['password' => Hash::make($request->password)]);
            return redirect(URL::to('admin/users'))->with('success', trans('messages.success'));
        } else {
            return redirect()->back()->with('error', trans('messages.password_not_match'));
        }
    }
    public function changestatus(Request $request)
    {
        $users = User::where('id', $request->id)->update(['is_available' => $request->status]);
        if ($users) {
            return 1;
        } else {
            return 0;
        }
    }

    public function deleteuser(Request $request)
    {        
        $users = User::where('id', $request->id)->delete();
        if ($users) {
            Appointments::where('vendor_id', $request->id)->delete();
            AppointmentSlots::where('vendor_id', $request->id)->delete();
            Businesscard::where('vendor_id', $request->id)->delete();
            Businesscontact::where('vendor_id', $request->id)->delete();
            Inquiry::where('vendor_id', $request->id)->delete();
            PromotionalVideos::where('vendor_id', $request->id)->delete();
            BusinessReorderSection::where('vendor_id', $request->id)->delete();
            Service::where('vendor_id', $request->id)->delete();
            Settings::where('vendor_id', $request->id)->delete();
            Testimonial::where('vendor_id', $request->id)->delete();
            Timings::where('vendor_id', $request->id)->delete();
            Transaction::where('vendor_id', $request->id)->delete();
            return 1;
        } else {
            return 0;
        }
    }

    public function changepassword(Request $request)
    {
        $request->validate(
            [
                'current_password' => 'required',
                'new_password' => 'required|different:current_password|min:6',
                'confirm_password' => 'required|same:new_password',
            ],
            [
                'current_password.required' => trans('messages.current_password_required'),
                'new_password.required' => trans('messages.new_password_required'),
                'new_password.different' => trans('messages.new_password_diffrent'),
                'confirm_password.required' => trans('messages.confirm_password_required'),
                'confirm_password.same' => trans('messages.confirm_password_same')
            ]
        );
        if (Hash::check($request->current_password, Auth::user()->password)) {
            $user = User::find(Auth::user()->id);
            $user->password = Hash::make($request->new_password);
            $user->save();
            return redirect()->back()->with("success", trans('messages.success'));
        } else {
            return redirect()->back()->with("error", trans('messages.old_password_invalid'));
        }
    }
    public function verification(Request $request)
    {
        return view('admin.auth.verification');
    }
    public function otpverification(Request $request)
    {
        return view('admin.auth.otp-verification');
    }
    public function otpverify(Request $request)
    {
        $request->validate([
            'otp' => 'required',
        ], [
            'otp.required' => trans('messages.otp_required'),
        ]);
        $email = session()->get('verification_email');
        $checkuser = User::where('email', $email)->where('is_verified', 2)->first();
        if (!empty($checkuser)) {
            if ($checkuser->otp == $request->otp) {
                $checkuser->otp = null;
                $checkuser->is_verified = 1;
                $checkuser->save();
                session()->forget('verification_email');
                $settings = new Settings;
                $settings->vendor_id = Auth::user()->id;
                $settings->currency = helper::admin_info()->currency;
                $settings->currency_position = helper::admin_info()->currency_position;
                $settings->timezone = helper::admin_info()->timezone;
                $settings->web_title = helper::admin_info()->web_title;
                $settings->copyright = helper::admin_info()->copyright;
                $settings->logo = "default-logo.png";
                $settings->favicon = "default-favicon.png";
                $settings->save();
                return redirect(URL::to('admin'))->with('success', trans('messages.email_verified'));
            } else {
                return redirect()->back()->with('error', trans('messages.invalid_otp'));
            }
        } else {
            return redirect()->back()->with('error', trans('messages.invalid_user'));
        }
    }
    public function resendotp(Request $request)
    {
        $otp = rand(000000, 999999);
        $email = session()->get('verification_email');
        $name = Auth::user()->name;
        $msg = trans('messages.email_verification_code_here');
        User::where('email', $email)->first();
        $sendmail = helper::verification_mail($email, $name, $msg, $otp);
        if ($sendmail == 1) {
            Auth::user()->otp = $otp;
            Auth::user()->save();
            return redirect()->back()->with('success', trans('messages.otp_sent'));
        } else {
            return redirect()->back()->with('error', trans('messages.email_error'));
        }
    }
    public function forgotpassword(Request $request)
    {
        return view('admin.auth.forgotpassword');
    }
    public function sendpassword(Request $request)
    {
        $request->validate([
            'email' => 'required|email'
        ], [
            'email.required' => trans('messages.email_required'),
            'email.email' => trans('messages.valid_email'),
        ]);
        $checkuser = User::where('email', $request->email)->where('type', 2)->where('is_available', 1)->first();
        if (!empty($checkuser)) {
            $password = substr(str_shuffle('abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'), 0, 8);
            $name = $checkuser->name;
            $email = $request->email;
            $msg = trans('messages.email_verification_code_here');
            $sendmail = helper::sendpassword_mail($email, $name, $msg, $password);
            if ($sendmail == 1) {
                $checkuser->password = Hash::make($password);
                $checkuser->save();
                return redirect(URL::to('admin'))->with('success', trans('messages.password_sent'));
            } else {
                return redirect()->back()->with('error', trans('messages.email_error'));
            }
        } else {
            return redirect()->back()->with('error', trans('messages.invalid_email'));
        }
    }
    public function vendor_login(Request $request)
    {
        $user = User::find($request->id);
        Auth::login($user);
        session()->put('vendor_login', $user->name);
        return redirect('admin/dashboard')->with('success', trans('messages.success'));
    }

    public function admin_login(Request $request)
    {
        if (session()->has('vendor_login')) {
            $user = User::where('type', 1)->first();
            Auth::login($user);
            session()->forget('vendor_login');
            return redirect('admin/users')->with('success', trans('messages.success'));
        }

        return redirect()->back();
    }

    public function systemverification(Request $request)
    {
        if (ini_get('allow_url_fopen')) {
            $username = str_replace(' ', '', $request->envato_username);

            $payload = file_get_contents('https://paponapps.co.in/api/getdata.php?envato_username=' . $username . '&email=' . $request->email . '&purchase_key=' . $request->purchase_key . '&domain=' . $request->domain . '&purchase_type=Envato&version=1');

            $obj = json_decode($payload);

            if ($obj->status == '1') {
                return redirect('/admin')->with('success', 'You have successfully verified your License. Please try to Login now. If any query Contact us paponapp2244@gmail.com');
            } else {
                return redirect()->back()->with('error', $obj->message);
            }
        } else {
            return redirect()->back()->with('error', "allow_url_fopen is disabled. file_get_contents would not work. ASK TO YOUR SERVER SUPPORT TO ENABLE THIS 'allow_url_fopen' AND TRY AGAIN");
        }
    }
}
